/// <reference types="node" />
import * as Promise from 'bluebird';
import { EventEmitter } from 'events';
import * as http from 'http';
import * as net from 'net';
export declare type Middleware = (req: Request, cltSocket: net.Socket, head: Buffer, next: () => void) => void;
export declare type NetConnectPromise = (port: number, hostname: string, cltSocket: net.Socket, req: Request) => Promise<net.Socket>;
export declare class Request extends http.IncomingMessage {
    auth?: {
        username?: string;
        password?: string;
    };
}
export declare class Tunnel extends EventEmitter {
    private readonly stack;
    private readonly server;
    constructor();
    use(middleware: Middleware): void;
    private handleMiddleware;
    protected connect(port: number, host: string, _cltSocket: net.Socket, _req: Request): Promise<net.Socket>;
    listen: {
        (port?: number | undefined, hostname?: string | undefined, backlog?: number | undefined, listeningListener?: Function | undefined): http.Server;
        (port?: number | undefined, hostname?: string | undefined, listeningListener?: Function | undefined): http.Server;
        (port?: number | undefined, backlog?: number | undefined, listeningListener?: Function | undefined): http.Server;
        (port?: number | undefined, listeningListener?: Function | undefined): http.Server;
        (path: string, backlog?: number | undefined, listeningListener?: Function | undefined): http.Server;
        (path: string, listeningListener?: Function | undefined): http.Server;
        (options: net.ListenOptions, listeningListener?: Function | undefined): http.Server;
        (handle: any, backlog?: number | undefined, listeningListener?: Function | undefined): http.Server;
        (handle: any, listeningListener?: Function | undefined): http.Server;
    };
    close: (callback?: ((err?: Error | undefined) => void) | undefined) => http.Server;
}
export declare const basicAuth: Middleware;
